package net.minecraftforge.items.wrapper;

import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraftforge.items.IItemHandlerModifiable;
import net.minecraftforge.items.ItemHandlerHelper;

public class InvWrapper implements IItemHandlerModifiable
{
    public final IInventory inv;

    public InvWrapper(IInventory inv)
    {
        this.inv = inv;
    }

    @Override
    public boolean equals(Object o)
    {
        if (this == o)
            return true;
        if (o == null || getClass() != o.getClass())
            return false;

        InvWrapper that = (InvWrapper) o;

        return inv.equals(that.inv);

    }

    @Override
    public int hashCode()
    {
        return inv.hashCode();
    }

    @Override
    public int getSlots()
    {
        return inv.func_70302_i_();
    }

    @Override
    public ItemStack getStackInSlot(int slot)
    {
        return inv.func_70301_a(slot);
    }

    @Override
    public ItemStack insertItem(int slot, ItemStack stack, boolean simulate)
    {
        if (stack == null)
            return null;

        if (!inv.func_94041_b(slot, stack))
            return stack;

        ItemStack stackInSlot = inv.func_70301_a(slot);

        int m;
        if (stackInSlot != null)
        {
            if (!ItemHandlerHelper.canItemStacksStack(stack, stackInSlot))
                return stack;

            m = Math.min(stack.func_77976_d(), inv.func_70297_j_()) - stackInSlot.field_77994_a;

            if (stack.field_77994_a <= m)
            {
                if (!simulate)
                {
                    ItemStack copy = stack.func_77946_l();
                    copy.field_77994_a += stackInSlot.field_77994_a;
                    inv.func_70299_a(slot, copy);
                    inv.func_70296_d();
                }

                return null;
            }
            else
            {
                if (!simulate)
                {
                    ItemStack copy = stack.func_77979_a(m);
                    copy.field_77994_a += stackInSlot.field_77994_a;
                    inv.func_70299_a(slot, copy);
                    inv.func_70296_d();
                    return stack;
                }
                else
                {
                    stack.field_77994_a -= m;
                    return stack;
                }
            }
        }
        else
        {
            m = Math.min(stack.func_77976_d(), inv.func_70297_j_());
            if (m < stack.field_77994_a)
            {
                if (!simulate)
                {
                    inv.func_70299_a(slot, stack.func_77979_a(m));
                    inv.func_70296_d();
                    return stack;
                }
                else
                {
                    stack.field_77994_a -= m;
                    return stack;
                }
            }
            else
            {
                if (!simulate)
                {
                    inv.func_70299_a(slot, stack);
                    inv.func_70296_d();
                }
                return null;
            }
        }

    }

    @Override
    public ItemStack extractItem(int slot, int amount, boolean simulate)
    {
        if (amount == 0)
            return null;

        ItemStack stackInSlot = inv.func_70301_a(slot);

        if (stackInSlot == null)
            return null;

        if (simulate)
        {
            if (stackInSlot.field_77994_a < amount)
            {
                return stackInSlot.func_77946_l();
            }
            else
            {
                ItemStack copy = stackInSlot.func_77946_l();
                copy.field_77994_a = amount;
                return copy;
            }
        }
        else
        {
            int m = Math.min(stackInSlot.field_77994_a, amount);

            ItemStack decrStackSize = inv.func_70298_a(slot, m);
            inv.func_70296_d();
            return decrStackSize;
        }
    }

    @Override
    public void setStackInSlot(int slot, ItemStack stack)
    {
        inv.func_70299_a(slot, stack);
    }
}
